Index: s390-tools-sles11/ziomon/ziomon_util.c
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon_util.c
+++ s390-tools-sles11/ziomon/ziomon_util.c
@@ -24,18 +24,24 @@
 #include <sys/time.h>
 #include <getopt.h>
 #include <limits.h>
+#include <math.h>
 #include <assert.h>
 
 #include "ziomon_util.h"
 #include "zt_common.h"
 
 
-#define ZIOMON_UTIL_NAME	"ziomon_util"
+#ifdef WITH_MAIN
+const char *toolname = "ziomon_util";
+#else
+extern const char *toolname;
+#endif
+
 
 struct overall_result_wrp {
 	long			mtype;	/* must be long due to msg-passing
 					   interface */
-	struct overall_result   o_res;
+	struct utilization_data   o_res;
 };
 
 struct ioerr_wrp {
@@ -43,10 +49,10 @@ struct ioerr_wrp {
 	struct ioerr_data	data;
 };
 
-__u32 get_result_sz(struct overall_result *res)
+__u32 get_result_sz(struct utilization_data *res)
 {
-	return (sizeof(struct overall_result)
-		+ res->num_adapters * sizeof(struct adapter_result));
+	return (sizeof(struct utilization_data)
+		+ res->num_adapters * sizeof(struct adapter_utilization));
 }
 
 
@@ -57,154 +63,172 @@ __u32 get_ioerr_data_sz(struct ioerr_dat
 }
 
 
-void print_utilization_result(struct overall_result *res)
+void print_utilization_result(struct utilization_data *res)
 {
 	int i;
-	struct adapter_result	*a_res;
-	struct util_result	*u_res;
+	struct adapter_utilization	*a_res;
+	struct utilization_stats	*u_res;
+	time_t			 t;
 
-	printf("timestamp     : %s", ctime((time_t*)&res->timestamp));
+	t = res->timestamp;
+	printf("timestamp     : %s", ctime(&t));
 	printf("num adapters  : %d\n", res->num_adapters);
 	for (i = 0; i < res->num_adapters; ++i) {
-		a_res = &res->results[i];
-		u_res = &a_res->result;
+		a_res = &res->adapt_utils[i];
+		u_res = &a_res->stats;
 		if (i != 0)
 			printf("\n");
 		printf("utilization of host adapter %d\n", a_res->adapter_no);
 		printf("\tnum samples: %llu\n", (unsigned long long)u_res->count);
-		printf("\tqueue full incidents: %d\n", u_res->queue_full);
-		printf("\tadapter:\n");
-		print_stat_variance(&u_res->adapter, u_res->count);
-		printf("\tbus:\n");
-		print_stat_variance(&u_res->bus, u_res->count);
-		printf("\tprocessor:\n");
-		print_stat_variance(&u_res->cpu, u_res->count);
+		if (u_res->count > 0) {
+			printf("\tqueue full incidents: %d\n", u_res->queue_full);
+			printf("\taverage queue utilization: %.1lf slots\n",
+				u_res->queue_util_integral / (double)u_res->queue_util_interval);
+			printf("\tadapter:\n");
+			print_abbrev_stat(&u_res->adapter, u_res->count);
+			printf("\tbus:\n");
+			print_abbrev_stat(&u_res->bus, u_res->count);
+			printf("\tprocessor:\n");
+			print_abbrev_stat(&u_res->cpu, u_res->count);
+		}
 	}
 }
 
 
-static void swap_overall_result(struct overall_result *res)
+static void swap_overall_result(struct utilization_data *res)
 {
 	int i;
-	struct adapter_result *a_res;
-	struct util_result *u_res;
+	struct adapter_utilization *a_res;
+	struct utilization_stats *u_res;
 
 	swap_64(res->timestamp);
 
 	for (i = 0; i < res->num_adapters; ++i) {
-		a_res = &res->results[i];
+		a_res = &res->adapt_utils[i];
 		swap_32(a_res->adapter_no);
 		swap_16(a_res->valid);
-		u_res = &a_res->result;
+		u_res = &a_res->stats;
 		swap_64(u_res->count);
 		swap_32(u_res->queue_full);
 		swap_64(u_res->queue_util_integral);
 		swap_64(u_res->queue_util_interval);
-		swap_stat_variance(&u_res->adapter);
-		swap_stat_variance(&u_res->bus);
-		swap_stat_variance(&u_res->cpu);
+		swap_abbrev_stat(&u_res->adapter);
+		swap_abbrev_stat(&u_res->bus);
+		swap_abbrev_stat(&u_res->cpu);
 	}
 }
 
 
-void conv_overall_result_to_BE(struct overall_result *res)
+void conv_overall_result_to_BE(struct utilization_data *res)
 {
 	swap_overall_result(res);
 	swap_16(res->num_adapters);
 }
 
 
-void conv_overall_result_from_BE(struct overall_result *res)
+void conv_overall_result_from_BE(struct utilization_data *res)
 {
 	swap_16(res->num_adapters);
 	swap_overall_result(res);
 }
 
 
-static struct adapter_result *get_result_no(struct overall_result *res, int no)
+int compare_hctl_idents(const struct hctl_ident *src,
+			const struct hctl_ident *tgt)
 {
-	int i;
-
-	for (i = 0; i < res->num_adapters; ++i) {
-		if (res->results[i].adapter_no == no)
-			return &res->results[i];
+	if (src->host == tgt->host) {
+		if (src->channel == tgt->channel) {
+			if (src->target == tgt->target)
+				return (src->lun - tgt->lun);
+			else
+				return (src->target - tgt->target);
+		}
+		else
+			return (src->channel - tgt->channel);
 	}
-
-	return NULL;
+	else
+		return (src->host - tgt->host);
 }
 
-
-void aggregate_utilization_data(struct overall_result *src,
-				struct overall_result *tgt)
+void aggregate_utilization_data(const struct utilization_data *src,
+				struct utilization_data *tgt)
 {
-	struct adapter_result	*src_a_res, *tgt_a_res;
 	int i;
 
 	assert(tgt->timestamp = src->timestamp);
 	tgt->timestamp = src->timestamp;
 
 	if (src->num_adapters != tgt->num_adapters)
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Warning: inconsistent"
-			" number of adapters: %d %d\n", src->num_adapters,
-			tgt->num_adapters);
-
-	for (i = 0; i < src->num_adapters; ++i) {
-		src_a_res = &src->results[i];
-		if (!src_a_res->valid)
-			continue;
-		tgt_a_res = get_result_no(tgt, src_a_res->adapter_no);
-		tgt_a_res->result.queue_full += src_a_res->result.queue_full;
-		tgt_a_res->result.queue_util_integral +=
-					src_a_res->result.queue_util_integral;
-		tgt_a_res->result.queue_util_interval +=
-					src_a_res->result.queue_util_interval;
-		tgt_a_res->result.count += src_a_res->result.count;
-		aggregate_stat_variance(&src_a_res->result.adapter,
-				&tgt_a_res->result.adapter);
-		aggregate_stat_variance(&src_a_res->result.bus,
-				&tgt_a_res->result.bus);
-		aggregate_stat_variance(&src_a_res->result.cpu,
-				&tgt_a_res->result.cpu);
-	}
+		fprintf(stderr, "%s: Warning: inconsistent"
+			" number of adapters: %d %d\n", toolname,
+			src->num_adapters, tgt->num_adapters);
+
+	for (i = 0; i < src->num_adapters; ++i)
+		aggregate_adapter_result(&src->adapt_utils[i], &tgt->adapt_utils[i]);
 
 	return;
 }
 
 
+void aggregate_adapter_result(const struct adapter_utilization *src,
+			      struct adapter_utilization *tgt)
+{
+	if (src->valid) {
+		/* in case we aggregate over different adapters,
+		   we clearly indicate that this is not valid anymore */
+		if (src->adapter_no != tgt->adapter_no)
+			tgt->adapter_no = -1;
+
+		tgt->stats.queue_full += src->stats.queue_full;
+		tgt->stats.queue_util_integral +=
+					src->stats.queue_util_integral;
+		tgt->stats.queue_util_interval +=
+					src->stats.queue_util_interval;
+		tgt->stats.count += src->stats.count;
+		aggregate_abbrev_stat(&src->stats.adapter,
+				&tgt->stats.adapter);
+		aggregate_abbrev_stat(&src->stats.bus,
+				&tgt->stats.bus);
+		aggregate_abbrev_stat(&src->stats.cpu,
+				&tgt->stats.cpu);
+	}
+}
+
+
 void print_ioerr_data(struct ioerr_data *data)
 {
 	int i;
 	struct ioerr_cnt *cnt;
+	time_t		  t;
 
-	fprintf(stdout, "timestamp : %s", ctime((time_t*)&data->timestamp));
+	t = data->timestamp;
+	fprintf(stdout, "timestamp : %s", ctime(&t));
 	fprintf(stdout, "num luns  : %lld\n", (long long)data->num_luns);
 	for (i = 0; i < data->num_luns; ++i) {
 		cnt = &data->ioerrors[i];
-		fprintf(stdout, "\t%d:%d:%d:%d: %lld I/O errors\n", cnt->host,
-			cnt->channel, cnt->target, cnt->lun,
+		fprintf(stdout, "\t%d:%d:%d:%d: %lld I/O errors\n",
+			cnt->identifier.host, cnt->identifier.channel,
+			cnt->identifier.target, cnt->identifier.lun,
 			(long long)cnt->num_ioerr);
 	}
 }
 
-
 static void swap_ioerr_data(struct ioerr_data *data)
 {
 	int i;
 	struct ioerr_cnt *cnt;
 
-
 	swap_64(data->timestamp);
 	for (i = 0; i < data->num_luns; ++i) {
 		cnt = &data->ioerrors[i];
-		swap_32(cnt->host);
-		swap_32(cnt->channel);
-		swap_32(cnt->target);
-		swap_32(cnt->lun);
+		swap_32(cnt->identifier.host);
+		swap_32(cnt->identifier.channel);
+		swap_32(cnt->identifier.target);
+		swap_32(cnt->identifier.lun);
 		swap_64(cnt->num_ioerr);
 	}
 }
 
-
 void conv_ioerr_data_to_BE(struct ioerr_data *data)
 {
 	swap_ioerr_data(data);
@@ -219,14 +243,25 @@ void conv_ioerr_data_from_BE(struct ioer
 }
 
 
-void aggregate_ioerr_data(struct ioerr_data *src, struct ioerr_data *tgt)
+void aggregate_ioerr_cnt(const struct ioerr_cnt *src, struct ioerr_cnt *tgt)
+{
+	/* in case we aggregate over different devices,
+	   we clearly indicate that this is not valid anymore */
+	if (compare_hctl_idents(&src->identifier, &tgt->identifier) != 0)
+		memset(&tgt->identifier, 0xff, sizeof(struct hctl_ident));
+
+	tgt->num_ioerr += src->num_ioerr;
+}
+
+
+void aggregate_ioerr_data(const struct ioerr_data *src, struct ioerr_data *tgt)
 {
 	int i;
 
 	assert(tgt->timestamp <= src->timestamp);
 	tgt->timestamp = src->timestamp;
 	for (i=0; i<src->num_luns; ++i)
-		tgt->ioerrors[i].num_ioerr += src->ioerrors[i].num_ioerr;
+		aggregate_ioerr_cnt(&src->ioerrors[i], &tgt->ioerrors[i]);
 }
 
 
@@ -249,9 +284,9 @@ struct util_data {
 	__u64			queue_util_prev; /* previous absolut value
 						    of queue_util_integral */
 	struct timeval		queue_util_timestamp;
-	struct stat_variance 	adapter;
-	struct stat_variance 	bus;
-	struct stat_variance 	cpu;
+	struct abbrev_stat 	adapter;
+	struct abbrev_stat 	bus;
+	struct abbrev_stat 	cpu;
 	long count;
 };
 
@@ -322,10 +357,10 @@ static void deinit_opts(struct options *
 		free(opts->host_path);
 		opts->host_path = NULL;
 	}
-	opts->num_hosts_a = 0;
-	opts->msg_q = -1;
 	for (i=0; i<opts->num_hosts_a; ++i)
 		free(opts->luns[i]);
+	opts->num_hosts_a = 0;
+	opts->msg_q = -1;
 	free(opts->luns);
 	free(opts->luns_prev);
 }
@@ -333,9 +368,9 @@ static void deinit_opts(struct options *
 
 static void init_util_data(struct util_data *data)
 {
-	init_stat_variance(&data->adapter);
-	init_stat_variance(&data->bus);
-	init_stat_variance(&data->cpu);
+	init_abbrev_stat(&data->adapter);
+	init_abbrev_stat(&data->bus);
+	init_abbrev_stat(&data->cpu);
 	data->count = 0;
 }
 
@@ -343,8 +378,9 @@ static void init_util_data(struct util_d
 static int init_ioerr_cnt(struct ioerr_cnt *cnt, char *str)
 {
 	cnt->num_ioerr = 0;
-	return (sscanf(str, "%d:%d:%d:%d", &cnt->host, &cnt->channel,
-		       &cnt->target, &cnt->lun) == 5);
+	return (sscanf(str, "%d:%d:%d:%d", &cnt->identifier.host,
+		       &cnt->identifier.channel, &cnt->identifier.target,
+		       &cnt->identifier.lun) == 5);
 }
 
 
@@ -361,22 +397,22 @@ static int init_host_opts(struct options
 
 	opts->host_nr = calloc(num_hosts, sizeof(long));
 	if (!opts->host_nr) {
-	     fprintf(stderr, ZIOMON_UTIL_NAME ": calloc opts->host_nr: %s\n",
-		     strerror(errno));
+	     fprintf(stderr, "%s: calloc opts->host_nr: %s\n",
+			toolname, strerror(errno));
 	     return -1;
 	}
 	opts->host_path = malloc(num_hosts * sizeof(char *));
 	if (!opts->host_path) {
-	     fprintf(stderr, ZIOMON_UTIL_NAME ": malloc opts->host_path: %s\n",
-		     strerror(errno));
+	     fprintf(stderr, "%s: malloc opts->host_path: %s\n",
+			toolname, strerror(errno));
 	     return -1;
 	}
 	for (i = 0; i < num_hosts; ++i) {
-		opts->host_path[i] = malloc(sizeof(char)*MAX_HOST_PATH_LEN);
+		opts->host_path[i] = malloc(sizeof(char) * MAX_HOST_PATH_LEN + 1);
 		if (!opts->host_path[i]) {
-		     fprintf(stderr, ZIOMON_UTIL_NAME ": malloc"
-			     " opts->host_path[]: %s\n", strerror(errno));
-		     return -1;
+			fprintf(stderr, "%s: malloc opts->host_path[]: %s\n",
+				toolname, strerror(errno));
+			return -1;
 		}
 	}
 
@@ -385,16 +421,16 @@ static int init_host_opts(struct options
 	free(opts->luns_prev);
 	opts->luns_prev = calloc(num_hosts, sizeof(__u32));
 	if (!opts->luns || !opts->luns_prev) {
-	     fprintf(stderr, ZIOMON_UTIL_NAME ": malloc opts->luns: %s\n",
-		     strerror(errno));
+	     fprintf(stderr, "%s: malloc opts->luns: %s\n",
+			toolname, strerror(errno));
 	     return -1;
 	}
 	for (i = 0; i < num_hosts; ++i) {
-		opts->luns[i] = malloc(sizeof(char)*MAX_HOST_PATH_LEN);
+		opts->luns[i] = malloc(sizeof(char) * MAX_LUN_PATH_LEN + 1);
 		if (!opts->host_path[i]) {
-		     fprintf(stderr, ZIOMON_UTIL_NAME ": malloc"
-			     " opts->host_path[]: %s\n", strerror(errno));
-		     return -1;
+			fprintf(stderr, "%s: malloc opts->luns[]: %s\n",
+				toolname, strerror(errno));
+			return -1;
 		}
 	}
 	opts->num_hosts_a = num_hosts;
@@ -421,8 +457,8 @@ static int read_attribute(char *path, ch
 		goto out;
 	}
 	rc = 0;
-out:
 	close(fd);
+out:
 	if (status)
 		*status = rc;
 
@@ -435,7 +471,7 @@ static int poll_utilization(struct adapt
 {
 	char line[LINE_LEN];
 	int cpu, bus, adapter;
-	int rc = 0;
+	int rc = 0, grc = 0;
 	struct adapter_data *adpt;
 	struct util_data    *u_data;
 	int i;
@@ -444,19 +480,21 @@ static int poll_utilization(struct adapt
 		adpt = &all_adapters->adapters[i];
 		u_data = &adpt->data;
 		/* read utilization attribute */
-		if (read_attribute(adpt->path, line, &adpt->status))
+		if (read_attribute(adpt->path, line, &adpt->status)) {
+			grc++;
 			continue;
+		}
 		rc = sscanf(line, "%d %d %d", &cpu, &bus, &adapter);
 		if (rc != 3) {
-			fprintf(stderr, ZIOMON_UTIL_NAME ": Warning:"
-				" Could not parse %s: %s\n", line,
-				strerror(errno));
+			fprintf(stderr, "%s: Warning:"
+				" Could not parse %s: %s\n", toolname,
+				line, strerror(errno));
 			adpt->status = 3;
 			continue;
 		}
-		update_stat_variance(&u_data->adapter, adapter);
-		update_stat_variance(&u_data->bus, bus);
-		update_stat_variance(&u_data->cpu, cpu);
+		update_abbrev_stat(&u_data->adapter, adapter);
+		update_abbrev_stat(&u_data->bus, bus);
+		update_abbrev_stat(&u_data->cpu, cpu);
 
 		verbose_msg("data read for adapter %d: adapter=%d, bus=%d,"
 			    " cpu=%d\n",
@@ -465,7 +503,23 @@ static int poll_utilization(struct adapt
 		u_data->count++;
 	}
 
-	return 0;
+	return grc;
+}
+
+
+static int calc_overflow(__u64 old_val, __u64 new_val)
+{
+	double ofl_val = 0;
+	int i = 0;
+
+	assert(old_val > new_val);
+
+	while (ofl_val < old_val) {
+		ofl_val = pow(2, i);
+		++i;
+	}
+
+	return (new_val + (int)(ofl_val - old_val));
 }
 
 
@@ -490,32 +544,37 @@ static int poll_queue_full(int init, str
 			continue;
 		rc = sscanf(line, "%d %Lu", &queue_full_tmp, &queue_util_tmp);
 		if (rc == 1) {
-			fprintf(stderr, ZIOMON_UTIL_NAME ": Only one value in"
+			fprintf(stderr, "%s: Only one value in"
 				" %s, your kernel level is probably too old.\n",
-				adpt->q_full_path);
+				toolname, adpt->q_full_path);
 			return -1;
 		}
 		if (rc != 2) {
-			fprintf(stderr, ZIOMON_UTIL_NAME ": Warning:"
-				" Could not parse %s: %s\n", line,
-				strerror(errno));
+			fprintf(stderr, "%s: Warning:"
+				" Could not parse %s: %s\n",
+				toolname, line,	strerror(errno));
 			adpt->status = 6;
 			continue;
 		}
 		gettimeofday(&cur_time, NULL);
 		if (!init) {
-			u_data->queue_full = queue_full_tmp
+			if (queue_full_tmp < u_data->queue_full_prev)
+				u_data->queue_full =
+					calc_overflow(u_data->queue_full_prev,
+						      queue_full_tmp);
+			else
+				u_data->queue_full = queue_full_tmp
 						- u_data->queue_full_prev;
-			u_data->queue_util_integral = queue_util_tmp
+			if (queue_util_tmp < u_data->queue_util_prev)
+				u_data->queue_util_integral =
+					calc_overflow(u_data->queue_util_prev,
+							queue_util_tmp);
+			else
+				u_data->queue_util_integral = queue_util_tmp
 						- u_data->queue_util_prev;
-			timersub(&cur_time, &u_data->queue_util_timestamp,
-						&tmp);
+			timersub(&cur_time, &u_data->queue_util_timestamp, &tmp);
 			u_data->queue_util_interval = tmp.tv_sec * 1000000
 							+ tmp.tv_usec;
-			verbose_msg("data read for adapter %d: queue_full=%d,"
-				    " queue_util=%Lu\n", adpt->host_nr,
-				    u_data->queue_full, (long long unsigned int)
-				    u_data->queue_util_integral);
 		}
 		u_data->queue_full_prev = queue_full_tmp;
 		u_data->queue_util_prev = queue_util_tmp;
@@ -530,7 +589,7 @@ static int poll_ioerr_cnt(int init, stru
 			  struct options *opts)
 {
 	char line[LINE_LEN];
-	int rc = 0;
+	int rc = 0, grc = 0;
 	int i, tmp;
 
 	if (!init)
@@ -538,26 +597,33 @@ static int poll_ioerr_cnt(int init, stru
 	for (i=0; i<opts->num_luns; ++i) {
 		/* read ioerr_cnt attribute */
 		if (read_attribute(opts->luns[i], line, NULL)) {
-			fprintf(stderr, ZIOMON_UTIL_NAME ": Warning:"
-				" Could read %s\n", opts->luns[i]);
+			fprintf(stderr, "%s: Warning: Could not read %s\n",
+				toolname, opts->luns[i]);
+			grc++;
 			continue;
 		}
 		rc = sscanf(line, "%i", &tmp);
 		if (rc != 1) {
-			fprintf(stderr, ZIOMON_UTIL_NAME ": Warning:"
-				" Could not parse ioerr line %s: %s\n", line,
-				strerror(errno));
+			fprintf(stderr, "%s: Warning:"
+				" Could not parse ioerr line %s: %s\n",
+				toolname, line,	strerror(errno));
+			grc++;
 			continue;
 		}
 		if (!init) {
-			data->ioerrors[i].num_ioerr = tmp - opts->luns_prev[i];
+			if (tmp < opts->luns_prev[i])
+				data->ioerrors[i].num_ioerr = calc_overflow(
+						opts->luns_prev[i], tmp);
+			else
+				data->ioerrors[i].num_ioerr = tmp
+							- opts->luns_prev[i];
 			verbose_msg("data read for i/o err %s: ioerr_cnt=%d\n",
 			    opts->luns[i], data->ioerrors[i].num_ioerr);
 		}
 		opts->luns_prev[i] = tmp;
 	}
 
-	return 0;
+	return grc;
 }
 
 
@@ -573,7 +639,8 @@ static void reinit_adapters(struct adapt
 static int init_adapters(struct adapters *all_adapters, struct options *opts)
 {
 	struct adapter_data *adapter;
-	int i;
+	struct stat buf;
+	int i, rc = 0;
 
 	if (opts)
 		all_adapters->num_adapters = opts->num_hosts;
@@ -585,10 +652,20 @@ static int init_adapters(struct adapters
 			adapter->path = malloc(sizeof(char)*MAX_HOST_PATH_LEN);
 			sprintf(adapter->path, "%s/utilization",
 				opts->host_path[i]);
+			if (stat(adapter->path, &buf)) {
+				fprintf(stderr, "%s: Path does not exist: %s - correct kernel version?\n",
+					toolname, adapter->path);
+				rc++;
+			}
 			adapter->q_full_path =
 				malloc(sizeof(char)*MAX_HOST_PATH_LEN);
 			sprintf(adapter->q_full_path, "%s/queue_full",
 				opts->host_path[i]);
+			if (stat(adapter->path, &buf)) {
+				fprintf(stderr, "%s: Path does not exist: %s - correct kernel version?\n",
+					toolname, adapter->q_full_path);
+				rc++;
+			}
 			adapter->status = 0;
 		}
 		init_util_data(&all_adapters->adapters[i].data);
@@ -596,7 +673,7 @@ static int init_adapters(struct adapters
 	if (poll_queue_full(1, all_adapters, opts))
 		return -1;
 
-	return 0;
+	return rc;
 }
 
 
@@ -624,29 +701,28 @@ static int init_ioerr_wrp(struct ioerr_w
 	*wrp = malloc(sizeof(struct ioerr_wrp)
 		     + opts->num_luns*sizeof(struct ioerr_cnt));
 	if (!*wrp) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: "
-			"Memory allocation\n");
+		fprintf(stderr, "%s: Memory allocation failed\n", toolname);
 		return -1;
 	}
 	(*wrp)->mtype = opts->msg_id_ioerr;
 	(*wrp)->data.num_luns = opts->num_luns;
 	for (i=0; i<opts->num_luns; ++i) {
 		if (init_ioerr_cnt(&(*wrp)->data.ioerrors[i], opts->luns[i])) {
-			fprintf(stderr, ZIOMON_UTIL_NAME ": Error: "
-				"Could not parse %s\n", opts->luns[i]);
+			fprintf(stderr, "%s: Could not parse %s\n",
+				toolname, opts->luns[i]);
 			return -2;
 		}
 		strcpy(tmp, opts->luns[i]);
 		sprintf(opts->luns[i], "/sys/bus/scsi/devices/%s/ioerr_cnt", tmp);
 		if (stat(opts->luns[i], &buf)) {
-			fprintf(stderr, ZIOMON_UTIL_NAME ": Error: "
-				"Could not open %s: %s\n", opts->luns[i], strerror(errno));
+			fprintf(stderr, "%s: Could not open %s: %s\n",
+				toolname, opts->luns[i], strerror(errno));
 			return -3;
 		}
 	}
 	if (poll_ioerr_cnt(1, NULL, opts)) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: "
-			"Could not read initial values of ioerr attributes.\n");
+		fprintf(stderr, "%s: Could not read initial values of ioerr"
+			" attributes.\n", toolname);
 		return -1;
 	}
 
@@ -657,8 +733,7 @@ static int init_ioerr_wrp(struct ioerr_w
 static void init_result_wrp(struct overall_result_wrp **res, int num_adapters,
 			    struct options *opts)
 {
-	*res = malloc(sizeof(struct overall_result_wrp)
-		      + (num_adapters * sizeof(struct adapter_result)));
+	*res = malloc(sizeof(struct overall_result_wrp) + (num_adapters * sizeof(struct adapter_utilization)));
 	(*res)->o_res.num_adapters = num_adapters;
 	(*res)->mtype = opts->msg_id;
 }
@@ -671,11 +746,11 @@ static void deinit_result_wrp(struct ove
 }
 
 
-static void print_version(const char *name)
+static void print_version(void)
 {
-        fprintf(stdout, "%s: ziomon utilization monitor, version %s.\n"
-               "Copyright IBM Corp. 2008.\n",
-               name, RELEASE_STRING);
+        fprintf(stdout, "%s: ziomon utilization monitor, version %s\n"
+               "Copyright IBM Corp. 2008\n",
+               toolname, RELEASE_STRING);
 }
 
 
@@ -684,20 +759,20 @@ static int get_argument_long(char *progn
 	char *p;
 
 	if (!optarg) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: Argument missing"
-			" to option %c\n", opt);
+		fprintf(stderr, "%s: Argument missing"
+			" to option %c\n", toolname, opt);
 		return -1;
 	}
 	*param = strtol(optarg, &p, 0);
 	if (errno) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: Unrecognized"
-			" parameter to option %c: %s\n", opt,
+		fprintf(stderr, "%s: Unrecognized"
+			" parameter to option %c: %s\n", toolname, opt,
 			strerror(errno));
 		return -2;
 	}
 	if (*p != '\0') {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: Unrecognized"
-			" parameter to option %c\n", opt);
+		fprintf(stderr, "%s: Unrecognized"
+			" parameter to option %c\n", toolname, opt);
 		return -3;
 	}
 
@@ -717,22 +792,24 @@ static int check_host_param(long *host_n
 	char *tmp;
 
 	if (*host_nr > 9999) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: Host number out"
-			" of range\n");
+		fprintf(stderr, "%s: Host number out"
+			" of range\n", toolname);
 		return -1;
 	}
 
 	sprintf(host_path, "/sys/class/scsi_host/host%ld", *host_nr);
 	if (stat(host_path, &buf)) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: Cannot access %s:"
-			" %s\n", host_path, strerror(errno));
+		fprintf(stderr, "%s: Cannot access %s:"
+			" %s\n", toolname, host_path, strerror(errno));
 		return -1;
 	}
 	tmp = malloc(strlen(host_path) + strlen("/queue_full") + 1);
 	sprintf(tmp, "%s/queue_full", host_path);
 	if (stat(host_path, &buf)) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: Cannot access %s:"
-			" %s\n", tmp, strerror(errno));
+		fprintf(stderr, "%s: Cannot access %s."
+			" Your installed kernel is probably too old. Please"
+			" check that your kernel matches the level in the"
+			" documentation.\n", toolname, tmp);
 		free(tmp);
 		return -1;
 	}
@@ -754,8 +831,7 @@ static int find_all_hosts(struct options
 	verbose_msg("no host adapter(s) specified, scanning...\n");
 	num_dirents = scandir(h_path, &namelist, hostdir_filter, alphasort);
 	if (num_dirents <= 0) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: No host adapter(s)"
-			" found\n");
+		fprintf(stderr, "%s: No host adapter(s) found\n", toolname);
 		rc = -3;
 		goto out;
 	}
@@ -767,8 +843,8 @@ static int find_all_hosts(struct options
 	for (i = 0; i < num_dirents; ++i) {
 		k = sscanf(namelist[i]->d_name, "host%ld", &opts->host_nr[i]);
 		if (k != 1) {
-			fprintf(stderr, ZIOMON_UTIL_NAME ": Error: Internal"
-				" error while scanning host adapter no\n");
+			fprintf(stderr, "%s: Internal error while scanning"
+				" host adapter no\n", toolname);
 			rc = -4;
 		} else
 			check_host_param(&opts->host_nr[i],
@@ -796,19 +872,19 @@ static int setup_msg_q(struct options *o
 	int wait=0;
 
 	if (opts->msg_id <= 0) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Invalid or missing msg"
-			" id for utilization messages\n");
+		fprintf(stderr, "%s: Invalid or missing msg"
+			" id for utilization messages\n", toolname);
 		return -1;
 	}
 	if (opts->msg_id_ioerr <= 0) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Invalid or missing msg"
-			" id for I/O error messages\n");
+		fprintf(stderr, "%s: Invalid or missing msg"
+			" id for I/O error messages\n", toolname);
 		return -1;
 	}
 	if (opts->msg_id == opts->msg_id_ioerr) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: Message IDs for"
+		fprintf(stderr, "%s: Message IDs for"
 			" I/O error count and utilization messages must be"
-			" different\n");
+			" different\n", toolname);
 		return -1;
 	}
 
@@ -820,12 +896,14 @@ static int setup_msg_q(struct options *o
 		opts->msg_q = msgget(util_q, S_IRWXU);
 		if (opts->msg_q >= 0) {
 			if (wait)
-				fprintf(stderr, "Message queue is up!\n");
+				fprintf(stderr, "%s: Message queue is up!\n",
+					toolname);
 			break;
 		}
 		if (!wait) {
 			wait = 1;
-			fprintf(stderr, "Warning: Message queue not up yet, waiting...\n");
+			fprintf(stderr, "%s: Warning: Message queue not"
+				" up yet, waiting...\n", toolname);
 		}
 		usleep(200000);
 	}
@@ -842,13 +920,13 @@ static int setup_msg_q(struct options *o
 }
 
 
-static void generate_result(struct overall_result *ures,
+static void generate_result(struct utilization_data *ures,
 			    struct adapters *all_adapters)
 {
 	struct adapter_data	*a_data;
 	struct util_data	*u_data;
-	struct adapter_result	*a_res;
-	struct util_result	*u_res;
+	struct adapter_utilization	*a_res;
+	struct utilization_stats	*u_res;
 	int i;
 
 	ures->num_adapters = all_adapters->num_adapters;
@@ -856,21 +934,19 @@ static void generate_result(struct overa
 
 	for (i = 0; i < all_adapters->num_adapters; ++i) {
 		a_data = &all_adapters->adapters[i];
-		a_res = &ures->results[i];
+		a_res = &ures->adapt_utils[i];
 		a_res->adapter_no = a_data->host_nr;
 		u_data = &a_data->data;
 		a_res->valid = u_data->count;
 		if (a_res->valid) {
-			u_res = &a_res->result;
+			u_res = &a_res->stats;
 			u_res->queue_full = u_data->queue_full;
-			u_res->queue_util_integral
-						= u_data->queue_util_integral;
-			u_res->queue_util_interval
-						= u_data->queue_util_interval;
+			u_res->queue_util_integral = u_data->queue_util_integral;
+			u_res->queue_util_interval = u_data->queue_util_interval;
 			u_res->count = u_data->count;
-			copy_stat_variance(&u_res->adapter, &u_data->adapter);
-			copy_stat_variance(&u_res->bus, &u_data->bus);
-			copy_stat_variance(&u_res->cpu, &u_data->cpu);
+			copy_abbrev_stat(&u_res->adapter, &u_data->adapter);
+			copy_abbrev_stat(&u_res->bus, &u_data->bus);
+			copy_abbrev_stat(&u_res->cpu, &u_data->cpu);
 		}
 	}
 }
@@ -878,12 +954,12 @@ static void generate_result(struct overa
 
 
 static const char help_text[] =
-    "Usage: " ZIOMON_UTIL_NAME " [-h] [-v] [-V] [-i n] [-s n] "
+    "Usage: ziomon_util [-h] [-v] [-V] [-i n] [-s n] "
             "[-Q <msgq_path> -q <msgq_id>\n"
     "                   -m <msg_id>] -d n -a <n> -l <lun>\n"
     "\n"
     "Start the monitor for the host adapter utilization.\n"
-    "Example: " ZIOMON_UTIL_NAME " -d 60 -i 4 -a 0\n"
+    "Example: ziomon_util -d 60 -i 4 -a 0\n"
     "\n"
     "-h, --help            Print usage information and exit.\n"
     "-v, --version         Print version information and exit.\n"
@@ -904,7 +980,7 @@ static const char help_text[] =
     "-L, --msg-id-ioerr    Specify the message id for I/O error count"
 			" messages.\n";
 
-static void print_help(const char *name)
+static void print_help(void)
 {
         fprintf(stdout, "%s", help_text);
 }
@@ -931,7 +1007,7 @@ static int parse_params(int argc, char *
 	};
 
 	if (argc <= 1) {
-		print_help(argv[0]);
+		print_help();
 		return 1;
 	}
 
@@ -954,8 +1030,8 @@ static int parse_params(int argc, char *
 			break;
 		case 'l':
 			if (!optarg) {
-				fprintf(stderr, ZIOMON_UTIL_NAME ": Error:"
-					 "Argument missing to option '-l'\n");
+				fprintf(stderr, "%s: Argument missing to"
+					" option '-l'\n", toolname);
 				return -1;
 			}
 			strcpy(opts->luns[opts->num_luns], optarg);
@@ -988,65 +1064,62 @@ static int parse_params(int argc, char *
 			break;
 		case 'Q':
 			if (!optarg) {
-				fprintf(stderr, ZIOMON_UTIL_NAME ": Error:"
-					" Argument missing to option '-Q'\n");
+				fprintf(stderr, "%s: Argument missing to"
+					" option '-Q'\n", toolname);
 				return -1;
 			}
 			opts->msg_q_path = optarg;
 			break;
 		case 'q':
 			if (!optarg) {
-				fprintf(stderr, ZIOMON_UTIL_NAME ": Error:"
-					 "Argument missing to option '-Q'\n");
+				fprintf(stderr, "%s: Argument missing to"
+					" option '-Q'\n", toolname);
 				return -1;
 			}
 			opts->msg_q_id = atoi(optarg);
 			if (opts->msg_q_id < 0) {
-				fprintf(stderr, ZIOMON_UTIL_NAME ": Error:"
-					" Parameter to option '-q' must be"
-					" greater than 0\n");
+				fprintf(stderr, "%s: Parameter to option '-q'"
+					" must be greater than 0\n", toolname);
 				return -1;
 			}
 			break;
 		case 'v':
-			print_version(argv[0]);
+			print_version();
 			return 1;
 		case 'h':
-			print_help(argv[0]);
+			print_help();
 			return 1;
 		default:
-			fprintf(stderr, ZIOMON_UTIL_NAME ": Try '"
-				ZIOMON_UTIL_NAME " --help' for more"
-				" information.\n");
+			fprintf(stderr, "%s: Try '%s --help' for more"
+				" information.\n", toolname, toolname);
 			return -1;
 		}
 	}
 
 	if (opts->duration < 0) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: No duration"
-			" specified\n");
+		fprintf(stderr, "%s: No duration specified\n", toolname);
 		return -1;
 	}
 	if (opts->i_duration < 0)
 		opts->i_duration = opts->duration;
 	if (opts->i_duration < opts->s_duration) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: Sample duration"
-			" must be at least the interval duration\n");
+		fprintf(stderr, "%s: Sample duration"
+			" must be at least the interval duration\n", toolname);
 		return -1;
 	}
 	if (opts->duration < opts->i_duration) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: Overall duration"
-			" must be at least the interval duration\n");
+		fprintf(stderr, "%s: Overall duration"
+			" must be at least the interval duration\n", toolname);
 		return -1;
 	}
-	if (opts->i_duration % opts->s_duration) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: Sample duration"
-			" must be a multiple of sample duration\n");
+	if (opts->s_duration && opts->i_duration % opts->s_duration) {
+		fprintf(stderr, "%s: Sample duration"
+			" must be a multiple of sample duration\n", toolname);
 		return -1;
 	}
-	if (opts->duration % opts->i_duration) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: overall duration"
-			" must be a multiple of section duration\n");
+	if (opts->i_duration && opts->duration % opts->i_duration) {
+		fprintf(stderr, "%s: overall duration"
+			" must be a multiple of section duration\n", toolname);
 		return -1;
 	}
 	if (opts->num_hosts > 0) {
@@ -1061,16 +1134,15 @@ static int parse_params(int argc, char *
 		if (find_all_hosts(opts))
 			return -1;
 	}
-	if ((opts->msg_q_path && (opts->msg_q_id < 0
-				 || opts->msg_id == LONG_MIN))
-	    || (opts->msg_q_id >= 0 && (!opts->msg_q_path
-				 || opts->msg_id == LONG_MIN))
-	    || (opts->msg_id != LONG_MIN && (!opts->msg_q_path
-				 || opts->msg_q_id < 0))) {
-		fprintf(stderr, ZIOMON_UTIL_NAME ": Error: Make sure to"
-			" specify all required arguments for message"
-			" queue.\n");
-		return -1;
+	if (opts->msg_q_path || opts->msg_q_id >= 0
+		|| opts->msg_id != LONG_MIN) {
+		if (!opts->msg_q_path || opts->msg_q_id < 0
+			|| opts->msg_id == LONG_MIN) {
+			fprintf(stderr, "%s: Make sure to"
+				" specify all required arguments for message"
+				" queue.\n", toolname);
+			return -1;
+		}
 	}
 
 	verbose_msg("num adapters        : %d\n", opts->num_hosts);
@@ -1092,10 +1164,10 @@ static void send_message(int msg_q, void
 		   though we should... */
 		if (errno == EIDRM) {
 			keep_running = 0;
-			verbose_msg("msgqueue removed, shutting down...");
+			verbose_msg("msgqueue removed, shutting down...\n");
 		} else {
-			fprintf(stderr, ZIOMON_UTIL_NAME ": Failed to send"
-				" message: %s\n", strerror(errno));
+			fprintf(stderr, "%s: Failed to send"
+				" message: %s\n", toolname, strerror(errno));
 			verbose_msg("msgsnd() returned error code %d\n",
 				    errno);
 		}
